 #include <stdio.h>
#include <stdlib.h>
#include <string.h>


#undef SG_GLOBAL
#include "sglite.h"

/*Max number of special positions (Pmmm)*/
#define SpePos_max 27

 
/* One special position */
typedef struct
{
   int nbEq; /* Number of relevant equations (1-3)*/
   
   int EqsABC[3][3];/* Ax+By+Cz+D=0, using STBF for d*/
   int EqsD[3];
   
   T_RTMx DirectMx;/* This is not a T_RTMx, but is used to write 
                     special positions in the "x,-x,1/2" way */
} T_SpePos;

/* All special positions in a given Sg*/
typedef struct
{
   int Mult;
   T_SpePos Eqs[SpePos_max];
} T_SgSpePos;

int PrintSpePosEq(const T_SpePos * SpePosEq)
{
   int i,j;
   T_RTMx fakeRTMx;
   for(i=0;i<3;i++)
   {
      fakeRTMx.s.T[i]=SpePosEq->EqsD[i];
      for(j=0;j<3;j++)
      {
         fakeRTMx.s.R[i*3+j]=SpePosEq->EqsABC[i][j];
      }
   }
   printf("    [%s]=[0,0,0]\n",RTMx2XYZ(&fakeRTMx,1,STBF,0,0,1,NULL,NULL,80));
   return 0;
}

int GetSymOpsIntersection(T_SpePos * SpePosEq, const T_RTMx *RTMx1, const T_RTMx *RTMx2)
{
   int i,j,nbEqs;
   /* Set up equation matrix */
   for(i=0;i<3;i++)
   {
      SpePosEq->EqsD[i]= (RTMx1->s.T[i]-RTMx1->s.T[i]) % STBF;
      if(SpePosEq->EqsD[i] <0) SpePosEq->EqsD[i] += STBF ;
      for(j=0;j<3;j++)
      {
         SpePosEq->EqsABC[i][j]= RTMx1->s.R[i*3+j]-RTMx1->s.T[i*3+j];
      }
   }
   /* Set up in row echelon format*/
   nbEqs=iRowEchelonFormT(&SpePosEq->EqsABC[0][0],3,3,&SpePosEq->EqsD[0],1);
   PrintSpePosEq(SpePosEq);
   return 0;
}

int RunSpecialPosTests(const T_SgOps *SgOps)
{
   int i;
   T_RTMx LISMx[SgOps->nSMx*SgOps->nLTr*SgOps->fInv];
   T_SpePos SpePosEq;
   T_RTMx RTMxI;
   
   /* Make Identity Mx*/
      for(i=0;i<9;i++) {RTMxI.s.R[i]=0;}
      for(i=0;i<3;i++)
      {
         RTMxI.s.R[(3+1)*i]=0;
         RTMxI.s.T[i]=0;
      }
   /*Generate all RTMx, including inversion centers & Translations */
      SetLISMx

   for(i=0;i<SgOps->nSMx;i++)
   {
      printf(" Symetry # \n");
      GetSymOpsIntersection(&SpePosEq,&SgOps->SMx[i],&RTMxI);
   }
}
